Attribute VB_Name = "modMain"
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Declare Function apiGetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)

Public Declare Function SHGetSpecialFolderPath Lib "shell32" Alias "SHGetSpecialFolderPathA" (ByVal hwndOwner As Long, ByVal pszPath As String, ByVal nFolder As Long, ByVal fCreate As Boolean) As Long
Public Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As Long) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Public Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)
Public Const NOERROR = 0
Public Const MAX_PATH = 260
Public Const CSIDL_DESKTOPDIRECTORY = &H10

Public Declare Function SendMessage Lib "USER32.DLL" Alias "SendMessageA" (ByVal hwnd As Long, ByVal dwMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const EM_UNDO = &HC7
Private Const WM_CUT = &H300
Private Const WM_COPY = &H301
Private Const WM_PASTE = &H302
Private Const WM_CLEAR = &H303
Private Const WM_UNDO = &H304


Global DLLFILE As String


Public optionFlag As Boolean

Dim compileError As Boolean

Public Function AppPath() As String
'This gets the app's path
If Right(App.Path, 1) = "\" Then AppPath = App.Path Else AppPath = App.Path & "\"
End Function

Public Sub InitDLLs()
    On Error Resume Next
    
    Dim Error As Boolean
    Dim dllPath As String, dllsNotFound As String
    
    Dim dllName1 As String

    dllName1 = "\DPPAPP.dll"

    
    '----- dllName1
    If FileExist(GetSystemDirectory & dllName1) Then 'check system folder
        DLLFILE = GetSystemDirectory & dllName1
    ElseIf FileExist(AppPath & dllName1) Then 'check current directory
        DLLFILE = AppPath & dllName1
    Else 'can't find it!
        dllsNotFound = dllName1
        DLLFILE = ""
    End If
    
finish:
If dllsNotFound <> "" Then _
    MsgBox "D++ SDE could not locate or was unable to load the following required files:" & vbCrLf & vbCrLf & dllsNotFound & vbCrLf & vbCrLf & "You will not be able to compile or run your projects.", vbExclamation, "D++ Error"
End Sub

Sub UninitDLL()
    Set CompileDLL = Nothing
    DLLLoaded = False
End Sub

Sub Pause(interval)
    'pause execution
    Current = Timer
    Do While Timer - Current < Val(interval)
        DoEvents
    Loop
End Sub

Public Function GetDesktopDirectory(hwnd As Long)
    'This function gets the desktop directory
    On Error GoTo NotExported
    Dim pidl As Long, sPath As String * MAX_PATH, nFolder As Long
    
    nFolder = CSIDL_DESKTOPDIRECTORY
    Call SHGetSpecialFolderPath(hwnd, sPath, nFolder, 0)
    If InStr(sPath, vbNullChar) > 1 Then
        GetDesktopDirectory = Left$(sPath, InStr(sPath, vbNullChar) - 1)
        Exit Function
    End If
    
NotExported:
    If SHGetSpecialFolderLocation(hwnd, nFolder, pidl) = NOERROR Then
        If pidl Then
            If SHGetPathFromIDList(pidl, sPath) Then
                GetDesktopDirectory = Left$(sPath, InStr(sPath, vbNullChar) - 1)
            End If
            Call CoTaskMemFree(pidl)
        End If
    End If
End Function

Public Function GetSystemDirectory() As String
    Dim strBuffer As String, lngReturn As String
    strBuffer = Space(255)
    lngReturn = apiGetSystemDirectory(strBuffer, Len(strBuffer))
    GetSystemDirectory = Left(strBuffer, lngReturn)
End Function

Sub AddDebug(TextToAdd As String)
    'adds text to the debug box
    frmMain.txtDebug.Text = frmMain.txtDebug.Text & TextToAdd & vbCrLf
    frmMain.txtDebug.selStart = Len(frmMain.txtDebug.Text)
End Sub

Public Function FileExist(ByVal fileName As String) As Boolean
    'Determines if a file exists
    On Error Resume Next
    If Dir(fileName, vbSystem + vbHidden) = "" Then
        FileExist = False
    Else
        FileExist = True
    End If
End Function

Function ReadFile(ByVal sFileName As String) As String
    'reads a file
    Dim fhFile As Integer
    fhFile = FreeFile
    Open sFileName For Binary As #fhFile
    ReadFile = Input$(LOF(fhFile), fhFile)
    Close #fhFile
End Function

Public Function GetFileName(FullPath As String) As String
    'This parses a full path to get the file name
    On Error Resume Next
    
    For i = Len(FullPath) To 1 Step -1
        sChar = Mid(FullPath, i, 1)
        If sChar = "\" Then
            GetFileName = StrReverse(GetFileName)
            Exit For
        End If
        GetFileName = GetFileName & sChar
    Next i
End Function

Public Function GetExtension(FullPath As String) As String
    'This parses a full path to get the file name
    On Error Resume Next
    
    For i = Len(FullPath) To 1 Step -1
        sChar = Mid(FullPath, i, 1)
        If sChar = "." Then
            GetExtension = StrReverse(GetExtension)
            Exit For
        End If
        GetExtension = GetExtension & sChar
    Next i
End Function

Function Crypt(Text) As String
    'a simple crypter
    For i = 1 To Len(Text)
        DoEvents
        Crypt = Crypt & Chr(255 - Asc(Mid(Text, i, 1)))
    Next i
End Function

Public Sub LaunchURL(URL As String)
    On Error Resume Next
    ret = MsgBox("Launch your web browser and navigate to this page?" & vbCrLf & vbCrLf & "   --> " & URL, vbInformation + vbYesNo, "Launch URL")
    If ret = vbYes Then _
        ShellExecute frmMain.hwnd, "Open", URL, 0, 0, 1
End Sub

Public Function BrowseCallbackProcStr(ByVal hwnd As Long, ByVal uMsg As Long, ByVal lParam As Long, ByVal lpData As Long) As Long
    If uMsg = 1 Then
        Call SendMessage(hwnd, BFFM_SETSELECTIONA, True, ByVal lpData)
    End If
End Function

Public Function FunctionPointer(FunctionAddress As Long) As Long
    FunctionPointer = FunctionAddress
End Function

Public Function getOptionKey() As String
getOptionKey = "߈߈ߝ߻ݾ߬ߐ"
getOptionKey = getOptionKey & "ߞ߯߯ߋߜߐ߻"
getOptionKey = getOptionKey & "ߖߖߓߦߩ߶ߪ"
getOptionKey = getOptionKey & "߹"
getOptionKey = Crypt(getOptionKey)
End Function

Public Sub Run(UseDOS As Boolean)
'On Error GoTo Errorh
Dim AppFile As String
Dim num As Integer

num = 1
begin:

AppFile = GetSetting("D++", "Options", "RunAt") & "\D++APP" & num & ".EXE"

CompileFile AppFile, True, UseDOS

SaveSetting "D++", "Memory", "Run", AppFile
    
Exit Sub
    
Errorh:
If Err.Number = 70 Then num = num + 1: GoTo begin: Exit Sub
AddDebug ">Compile Error " & Err.Number & ": " & Err.Description
AddDebug ">D++ Application Terminated"
End Sub

Public Sub MakeEXE(UseDOS As Boolean, AppFile As String)
On Error GoTo Errorh

If FileExist(AppFile) Then
    Overwrite = MsgBox("A file already exists by this name.  Overwrite?", 276, "File Found!")
    If Overwrite = 6 Then
        AddDebug ">EXE overwritten"
    Else
        AddDebug ">Canceled by user"
        AddDebug ">D++ Application Terminated"
        Exit Sub
    End If
End If

CompileFile AppFile, False, UseDOS

SaveSetting "D++", "Memory", "Compile", AppFile

Exit Sub

Errorh:
If Err.Number = 32755 Then
    AddDebug ">Canceled compile."
    Exit Sub
End If
AddDebug ">Compile Error " & Err.Number & ": " & Err.Description
AddDebug ">D++ Application Terminated"
End Sub


Public Sub CompileFile(FilePath As String, Link As Boolean, UseDOS As Boolean)


Dim SourceCode As String
Dim NewDebug As String
Dim Error As Boolean

Dim FileData As String, Header As String

On Error GoTo compileError

If DLLFILE = "" Then
    AddDebug ">Unable to locate DPPAPP.dll"
    AddDebug ">D++ Application Terminated"
    Exit Sub
End If

Running = True

AddDebug ">Running Pre-Processor ..."
SourceCode = preProcessor(frmMain.txtText.Text)

If compileError Then
    AddDebug ">D++ Application Terminated"
    Running = False
    Exit Sub
End If


    'AddDebug ">Assembling Header ..."
    If UseDOS Then                                                  'check if using dos...
        Header = "dppapp:type>dos>"                                 'set the header (dos)
    Else
        Header = "dppapp:type>dpp>"                                 'set the header (normal)
    End If

    If GetSetting("D++", "Options", "Encrypt") = "DPP:$D2>:" Then   'check encryption
        SourceCode = Crypt(SourceCode)                              'encrypt
        Header = Header & "crypt>T>"                                'set the header (crypt)
    Else
        Header = Header & "crypt>F>"                                'set the header (normal)
    End If

    If Not Link Then                                                'If we're not linking
        If GetSetting("D++", "Options", "Decompile") = "-1" Then    'if setting is true
            Header = Header & "read>f"                              'make it so it can't decompile
        Else
            Header = Header & "read>t"
        End If
    Else
        Header = Header & "read>t"                                  'make it so it can decompile
    End If
        
    Header = Header & ">dpp:"                                       'finish header
        
    AddDebug ">Compiling Project ..."                                'debug..
    FileNum = FreeFile 'get free file number

    'Read the DLL file and get the data
    Open DLLFILE For Binary As #FileNum
        FileData = Space$(LOF(FileNum)) 'set file data length
        Get #FileNum, , FileData 'get file data
    Close #FileNum

    FileNum = FreeFile 'get free file number

    'Write the new file to the location
    Open FilePath For Output As #FileNum
        'The new D++ file will be the DLL file, a header, and the code
        Print #FileNum, FileData & Header & SourceCode 'write file
    Close #FileNum

    If Link = True Then 'check if linking...
        AddDebug ">Linking " & FilePath & " ..." 'debug..
        Shell FilePath, vbNormalFocus 'run the file
    End If
    
    AddDebug ">D++ Compiler Finished."

Running = False


If Mid(frmMain.txtDebug.Text, Len(frmMain.txtDebug.Text) - 1, 2) = vbCrLf Then
    frmMain.txtDebug.Text = Mid(frmMain.txtDebug.Text, 1, Len(frmMain.txtDebug.Text) - 2)
End If
Exit Sub

compileError:
    AddDebug ">Compile Error " & Err.Number & ": " & Err.Description
    AddDebug ">D++ Application Terminated"
    Running = False
End Sub

Public Function preProcessor(Source As String) As String
    Dim lineArr() As String, i As Integer, z As Integer
    Dim arr() As String
    Dim tempString As String, includeFile As String
    Dim tested As Boolean
    
begin:
    lineArr = Split(Source, vbCrLf)
    For i = 0 To UBound(lineArr)
        If Left(LCase(lineArr(i)), 9) = "#include(" Then
            z = InStr(1, lineArr(i), ")")
            If z = 0 Then Error = "Expected end-paren.": GoTo syntaxError
            tempString = Mid(lineArr(i), 10, z - 10)
            includeFile = tempString
try:
            If FileExist(tempString) Then
                AddDebug ">Including file """ & tempString & """..."
                lineArr(i) = ReadFile(tempString)
            ElseIf Not tested Then
                tempString = AppPath & tempString
                tested = True
                GoTo try
            Else
                GoTo notFound
            End If
        ElseIf Left(LCase(lineArr(i)), 8) = "#define " Then
            arr = Split(lineArr(i), " ", 3)
            If UBound(arr) <> 2 Then Error = "Not enough arguments for #define": GoTo syntaxError
            lineArr(i) = ""
            Source = Join(lineArr, vbCrLf)
            Source = defineReplace(Source, arr(1), arr(2))
            GoTo begin
'        Else
'            If Left(lineArr(i), 1) <> "'" And Trim(lineArr(i)) <> "" Then
'                GoTo finish
'            End If
        End If
    Next i
    
    GoTo finish
    
syntaxError:
AddDebug ">Syntax Error: " & Error & " (Line " & (i + 1) & ")"
compileError = True
Exit Function

notFound:
AddDebug ">Error: Can't find include file """ & includeFile & """"
compileError = True
Exit Function

finish:
preProcessor = Join(lineArr, vbCrLf)
End Function

Public Function defineReplace(Source As String, toFind As String, toReplace As String)
Dim X As Long

X = 1

begin:
    X = CodeInStr(X, Source, toFind)
    If X = 0 Then defineReplace = Source: Exit Function

    Source = Mid(Source, 1, X - 1) & toReplace & Mid(Source, X + Len(toFind))
    X = X + Len(toReplace)
    GoTo begin

End Function

Public Function CodeInStr(ByVal StartPos As Long, ByVal SourceText As String, ByVal toFind As String) As Long
'This is just like InStr() only it skips over ""'s
Dim iPend As Long, i As Long, quote As Long
Dim sTemp As String

For i = StartPos To Len(SourceText)
    If LCase(Mid(SourceText, i, Len(toFind))) = LCase(toFind) Then
        CodeInStr = i
        Exit Function
    End If
                          
    If Mid(SourceText, i, 1) = Chr(34) Then
        quote = InStr(i + 1, SourceText, Chr(34))
        If quote > 0 Then i = quote
    End If
Next i
CodeInStr = 0
End Function

Public Function ReadEXE(sPath As String) As String
'Reads an EXE file and gets D++ source
On Error GoTo Error
Dim FileData As String, Header As String
Dim compileOpt1 As String, compileOpt2 As String, compileOpt3 As String
    
FileData = ReadFile(sPath)

If InStr(1, FileData, "dppapp:") = 0 Or InStr(1, FileData, "dpp:") = 0 Then
    If InStr(1, FileData, "DPP:$D2>:") = 0 Then
        ReadEXE = "'Note: No source code found."
        Exit Function
    Else
        ReadEXE = "'Note: This application was compiled in a " & vbCrLf & "'previous version of the D++ compiler." & vbCrLf & vbCrLf
        ReadEXE = ReadEXE & Crypt(Mid(FileData, InStr(1, FileData, "DPP:$D2>:") + 9))
        Exit Function
    End If
End If

Header = LCase(Mid(FileData, InStr(1, FileData, "dppapp:"), 35))
compileOpt1 = Mid(Header, 13, 3)
compileOpt2 = Mid(Header, 23, 1)
compileOpt3 = Mid(Header, 30, 1)

Select Case compileOpt1
    Case "dos", "dpp"
        'don't do anything, it's good
    Case "reg"
        ReadEXE = "'Note: This is a temporary EXE.  It does not contain source."
        Exit Function
    Case Else
        GoTo OldApp
End Select

If compileOpt2 = "t" Then 'Parse file to get source
    ReadEXE = Crypt(Mid(FileData, InStr(1, FileData, "dpp:") + 4))
ElseIf compileOpt2 = "f" Then
    ReadEXE = Mid(FileData, InStr(1, FileData, "dpp:") + 4)
Else
    GoTo OldApp
End If

If compileOpt3 = "f" Then
    ReadEXE = ""
ElseIf compileOpt3 <> "t" Then
    GoTo OldApp
End If
     
If ReadEXE = "" Then ReadEXE = "'Note: No source code found."

a = InStr(1, ReadEXE, "begindpp>")
If a <> 0 Then
    ReadEXE = Mid(ReadEXE, a + 9)
End If

If Right(ReadEXE, 2) = "" Then
    ReadEXE = Left(ReadEXE, Len(ReadEXE) - 2)
End If

Exit Function

Error:
MsgBox "Error " & Err.Number & " has occured: " & Err.Description, vbCritical, "Error"
Exit Function

OldApp:
ReadEXE = Crypt(Mid(FileData, InStr(1, FileData, "dpp:") + 4))
MsgBox "The EXE you have opened was a valid D++ EXE, but was outdated.  The source code was found, however it may need to be uscrambled.  If the code appears unreadable, you can try to unscramble it by clicking View->Scramble.  To fix this problem, please recomple the EXE.", vbExclamation, "D++ IDE"
End Function
